#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#define BUFSIZE 512

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

int main(int argc, char* argv[])
{
	int retval;

	if(argc < 2){
		fprintf(stderr, "[Usage] %s <ChattingID>\n", argv[0]);
		return -1;
	}

	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	if(!CreateProcess(NULL, "DisplayMessage", NULL, 
		NULL, FALSE, CREATE_NEW_CONSOLE, NULL, NULL, &si, &pi))
	{
		fprintf(stderr, "[] DisplayMessage.EXE ã  ϴ.\n");
		return -1;
	}

	// ǻ ̸ ˾Ƴ
	char compname[MAX_COMPUTERNAME_LENGTH+1];
	DWORD namelen = sizeof(compname);
	if(!GetComputerName(compname, &namelen)){
		fprintf(stderr, "[] GetComputerName()\n");
		return -1;
	}

	//  ʱȭ
	WSADATA wsa;
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		return -1;

	// socket()
	SOCKET sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");	
	
	// ƼĳƮ TTL 
	int ttl = 1;
	retval = setsockopt(sock, IPPROTO_IP, IP_MULTICAST_TTL,
		(char *)&ttl, sizeof(ttl));
	if(retval == SOCKET_ERROR) err_quit("setsockopt()");

	//  ּ ü ʱȭ
	SOCKADDR_IN remoteaddr;
	ZeroMemory(&remoteaddr, sizeof(remoteaddr));
	remoteaddr.sin_family = AF_INET;
	remoteaddr.sin_port = htons(9000);
	remoteaddr.sin_addr.s_addr = inet_addr("235.7.8.9");

	//  ſ  
	char buf[BUFSIZE+1];
	int len;
	char chatmsg[MAX_COMPUTERNAME_LENGTH+1 + BUFSIZE+1];

	// ƼĳƮ  
	while(1){
		//  Է
		printf("[޽ Է] ");
		if(fgets(buf, BUFSIZE+1, stdin) == NULL)
			break;

		// '\n'  
		len = strlen(buf);
		if(buf[len-1] == '\n')
			buf[len-1] = '\0';
		if(strlen(buf) == 0)
			break;

		wsprintf(chatmsg, "[%s:%s] %s", compname, argv[1], buf);

		//  
		retval = sendto(sock, chatmsg, strlen(chatmsg), 0, 
			(SOCKADDR *)&remoteaddr, sizeof(remoteaddr));
		if(retval == SOCKET_ERROR){
			err_display("sendto()");
			continue;
		}
	}

	// closesocket()
	closesocket(sock);

	//  
	WSACleanup();
	return 0;
}